/*  aqotdd - Afghan's Quote of the day server - An RFC865 compliant server.
    Copyright (C) 2000 Afghan Hound Software

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA*/

/* main.c - Sets stuff up, and runs the main select loop */

#include "main.h"

void first_init(int c,char **a)
{
  char *buffer=NULL;
  chdir("/");         /*Before anything else*/
  realloc1       = 0;
  realloc2       = 0;
  log_msg        = 1;
  config_parseoption(c,a);
  config_findfile();
  config_readfile();
  net_build_control_lists();
  net_init();
  daemon_init();
  signal_init();
  qotd_init();
  log_printready();
  if ((use_tcp==0)&&(use_udp==0))
    {
      buffer=qotd_getquote(buffer);
      while(strlen(buffer)>1024)
	{
	  free(buffer);
	  buffer=qotd_getquote(buffer);
	}
      my_message(MSG_ERRFAIL,"No protocols defined! - Here's a qotd anyway:\n",buffer);
    }

}

int main(int argc,char **argv)
{
  struct timeval timeout;
  int nscks;
  time_t now;


  first_init(argc,argv);
  now = time(NULL);
  while(1)
    {
      signal_check();
      FD_ZERO(&sockets);
      if (real_tcp){FD_SET(listen_fd_tcp,&sockets);highsocket=listen_fd_tcp;}
      if (real_udp){FD_SET(listen_fd_udp,&sockets);highsocket=listen_fd_udp;}
      timeout.tv_sec  = TIMEOUT; 
      timeout.tv_usec = 0;      
      nscks = select(highsocket+1, &sockets, (fd_set *) 0, (fd_set *) 0, &timeout);

      if ((nscks < 0))
	{
	  if (errno!=EINTR) /* Shouldn't be interrupted, but....*/
	  {
	      my_message(MSG_ERRFAIL,"Select failed in main loop",strerror(errno));
	  }
	}
      if (nscks > 0)
	{
	  net_read_sock();
	}
      if (time(NULL)!=now)
	{
	  tcp_connects = 0;
	  udp_connects = 0;
	  now = time(NULL);
	}
    }
  return(0);
}
